# CHANGELOG

## v0.4

### Breaking changes

* Moved and renamed current method `Rowlinson\Api\OrderClient::placeOrder()` to `Rowlinson\Api\BasketClient::confirm()` to correctly match its API category + function
* Created a new method `Rowlinson\Api\OrderClient::placeOrder()` that matches the `orders/place` API endpoint which places an order using passed values rather than the current basket

All classes within the `Rowlinson\Api\Requests` namespace are marked as `@internal` so you shouldn't be using these classes in your own code, however:

* Moved and renamed current class `Rowlinson\Api\Requests\Order\PlaceOrderRequest` to `Rowlinson\Api\Requests\Basket\ConfirmRequest` to match the method move
* Created a new class `Rowlinson\Api\Requests\Order\PlaceOrderRequest` to be used with the new `placeOrder` method,

### Non-breaking changes

* Added a new class `Rowlinson\Api\Requests\Order\DeliveryLocation` for new Delivery locations when placing an order, this is not marked as `@internal` and should be used in consumer code
* Added a new class `Rowlinson\Api\Requests\Order\Item` for basket items when placing an order, this is not marked as `@internal`

## v0.3.3

### Non-breaking changes

* Added an `invoiceAddress` property to `Rowlinson\Api\Responses\Organisation\OrganisationResponse`
* Added a `gln` property to `Rowlinson\Api\Responses\DeliveryLocation\DeliveryLocationResponse`

## v0.3.2

### Non-breaking changes

* Added a new method Rowlinson\Api\OrganisationClient::getContacts which will retrieve the contacts for an organisation (admin role users only)
* Added a new response class Rowlinson\Api\Responses\Organisation\ContactResponse for an organisation's contacts

## v0.3.1

### Non-breaking changes

* Rowlinson\Api\BasketClient::validate now correctly catches the 400 (Bad Request) response code that the API returns if the basket under validation has errors, before an exception would have been thrown

## v0.3

### Breaking changes

* Removed the `vatRate` property from `Rowlinson\Api\Responses\Product\ProductVariantResponse`, this property is now called `tax`

### Non-breaking changes

* Added `skuAlias`, `sortCode` and `totalPrice` properties to `Rowlinson\Api\Responses\Product\ProductVariantResponse`

## v0.2.1

### Non-breaking changes

* Added a new parameter to `Rowlinson\Api\ProductClient::getProducts()`, the method signature is now `int $page = 1, ?string $categoryId = null, array $skus = [], array $types = [], bool $includeVariants = false, ?string $organisationAlias = null`, this allows passing an organisation alias that will return that organisation's products if the authenticated user is an admin
* Added a new parameter to `Rowlinson\Api\ProductClient::getProductCount()`, the method signature is now `?string $categoryId = null, array $skus = [], array $types = [], ?string $organisationAlias = null` and allows for the same functionality as `getProducts()` above

## v0.2

### Breaking changes

* Moved the following methods from `Rowlinson\Api\UserClient` to `Rowlinson\Api\AuthClient`:
    - `login`
    - `logout`
    - `verify`
    - `verifyCredentials`
    - `impersonate`
    - `setApiKey`
* Moved the following methods from `Rowlinson\Api\UserClient` to `Rowlinson\Api\InviteClient`:
    - `invite`
    - `getInvite`
    - `resendInvite`
* Added a new parameter to `Rowlinson\Api\DeliveryLocationClient::getDeliveryLocations()`, the method signature used to be `int $page = 1, int $perPage = 10`, the new signature is `string $organisation = null, int $page = 1, int $perPage = 10`
* Moved `Rowlinson\Api\Responses\User\LoginResponse` to `Rowlinson\Api\Responses\Auth\LoginResponse`
* Moved `Rowlinson\Api\Responses\User\GetInviteResponse` to `Rowlinson\Api\Responses\Invites\GetInviteResponse`
* Moved `Rowlinson\Api\Requests\User\InviteRequest` to `Rowlinson\Api\Requests\Invite\InviteRequest`
* Moved `Rowlinson\Api\Requests\User\{ImpersonateRequest,LoginRequest,VerifyCredentialsRequest,VerifyRequest}` to `Rowlinson\Api\Requests\Auth` namespace

### Non-breaking changes

* Added a new method `Rowlinson\Api\AuthClient::sso()` to exchange an SSO token for an API key
* Added a new method `Rowlinson\Api\BasketClient::validate()` to send a collection of product variants with an optional organisation alias and receive errors and surcharge warnings back
* Added a new client `Rowlinson\Api\OrganisationClient` for fetching information about organisations, this is fetchable via the `createOrganisation()` method on `Rowlinson\Api\Sdk`
